//Simple scroll wheel implementation for Arduino Leonardo and similar
//Uses quadrature encoder and USB HID library
//CC-BY-NC 2020, M. Eric Carr / eric at paleotechnologist dot net

#include<Mouse.h>
int Sensitivity =1;
const int DATAPIN = 7;   //Phase A of encoder
const int CLOCKPIN = 8;  //Phase B of encoder
int selectButton;
int select2Button;

int mouseClickFlag = 0;

#define selPin  2
#define sel2Pin 3

void setup() {
  pinMode(selPin, INPUT);// set button select pin as input                                                                  // Pull button select pin high
  pinMode (sel2Pin,INPUT);
  pinMode(DATAPIN, INPUT);
  pinMode(CLOCKPIN, INPUT);
  attachInterrupt(digitalPinToInterrupt(selPin), RightClick, CHANGE);

  attachInterrupt(digitalPinToInterrupt(sel2Pin), LeftClick, CHANGE);

  Mouse.begin();
}

void loop() {
  selectButton = digitalRead(selPin);
  select2Button = digitalRead(sel2Pin);
  static int oldA=0,oldB=0;
  int a,b;

  a=digitalRead(DATAPIN);
  b=digitalRead(CLOCKPIN);
    if(Serial.available()){
    Sensitivity = Serial.parseInt();
    Serial.write(Sensitivity);
  }

  if(oldA!=a || oldB!=b){

    if(a==HIGH){
      if(b==LOW && oldB==HIGH){Mouse.move(0,0,+Sensitivity);}  //Scroll up
      if(b==HIGH && oldB==LOW){Mouse.move(0,0,-Sensitivity);} //Scroll down
      }

    oldA=a;
    oldB=b;

    }



  }
void RightClick(){
  if (digitalRead(selPin)){
    //Serial.println("Right click");
     Mouse.click(MOUSE_RIGHT);
  }else{
    //Serial.println("Release");
    Mouse.release(MOUSE_RIGHT);
  }
 delay(250);
// click the left button down

}

void LeftClick(){
if (digitalRead(sel2Pin)){
    //Serial.println("Right click");
    Mouse.click(MOUSE_LEFT);
  }else{
    //Serial.println("Release");
    Mouse.release(MOUSE_LEFT);
  }

   delay(250);

}
